#!/usr/local/bin/perl
#==============================================================================
# LinkScan
#==============================================================================
# (c) Copyright 1997-2007 Electronic Software Publishing Corporation (Elsop)
# All Rights Reserved.
# LinkScan(TM) and Elsop(TM) are
# Trademarks of Electronic Software Publishing Corporation
# WWW: http://www.elsop.com/  Email: linkscan@elsop.com
#
# See the file docs/license.txt for terms and conditions of use
#==============================================================================
$NXc='11.7';
print "\n";
print "Welcome to the LinkScan $NXc Configurator. This utility will help you\n";
print "configure LinkScan on your computer. It will complete the installation on\n";
print "many servers, but manual adjustment may be required on others. LinkScan\n";
print "prefers to be installed in its own directory (e.g. linkscan) under your web\n";
print "server root, but this is not mandatory.\n\n";
print "Your Server and Login names are:\n\n";

$enum=getpwuid($<);
$ueV=`uname -n`;
$ueV=~tr/\0\r\n//d;
print "Server Name: $ueV\n";
print "Login  Name: $enum\n\n";
$QiX='';
until($QiX=~m/^[yn]/i){
  print "Do you have a LinkScan License Key for this Server and Login? [y/n]: ";
  $QiX=<STDIN>;
  $QiX=~s/[\n\r]//g;
  if($QiX=~m/^n/i){
    print "\nIf you do not already have a LinkScan License Key, free evaluation\n";
    print "licenses are available from:\n\n";
    print "http://www.elsop.com/linkscan/dleval.cgi\n\n";
    print "If you need a modified License Key, please e-mail <key\@elsop.com>\n";
    print "Be sure to include the following information in your message:\n\n";
    print "* Your Name (or Company Name)\n";
    print "* Your Existing 10-Digit License Number\n";
    print "* Your Server Name: $ueV\n";
    print "* Your Login Name:  $enum\n\n";
    exit;
  }
}

$qZs='linkscan.sys';
$znL='default/linkscan.cfg';
$CWny=0;
open(TST,">>$qZs") || $CWny++;
close(TST);
open(TST,">>$znL") || $CWny++;
if($CWny){
  print "\n** Error: There appears to be a permissions problem\n";
  print "          Can't initialize linkscan.sys and default/linkscan.cfg\n\n";
  exit;
}

print "\n\nGood. Let's start by entering your License Key details.\n";
print "Enter the following License Key details *exactly* as they appear on\n";
print "the e-mail notification you received. If the backspace key echoes strange\n";
print "characters when entering this data, try using <control-H> instead.\n\n";
$nYtP='';
until($nYtP=~m/^\d{10,10}$/){
  print "Enter License Number [10 digits]: ";
  $nYtP=<STDIN>;
  $nYtP=~s/[\n\r\s]//g;
}
$hUp='';
until($hUp){
  print "Enter Licensee: ";
  $hUp=<STDIN>;
  $hUp=~s/[\n\r]//g;
}
$djTJ='';
until($djTJ=~m/\d+:\d+:\d+:\d+:\d+/){
  print "Enter License Key: ";
  $djTJ=<STDIN>;
  $djTJ=~s/[\n\r\s]//g;
}
print "\n\nEnter the name of your organization or web site as you wish it to\n";
print "appear on the LinkScan reports.\n";
$OXo='';
until($OXo){
  print "Enter Organization Name: ";
  $OXo=<STDIN>;
  $OXo=~s/[\n\r]//g;
}

$PhK=`pwd`;
$PhK=~s/[\r\n\s]//g;
until($PhK){
  print "\n\nThe LinkScan Configurator could not figure out the full pathname\n";
  print "to the current directory. Please enter it manually.\n";
  print "Enter Full Pathname to Current Directory: ";
  $PhK=<STDIN>;
  $PhK=~s/[\n\r\s]//g;
  stat($PhK);
  if(! -d _){print "Invalid entry: $PhK\n";$PhK='';}
}
unless($PhK=~m#/$#){$PhK .='/';}
$HzY=$PhK.'weblint/weblint';

print "\n\nNow LinkScan needs to know where to find some other programs.\n";
$pXOq='/usr/local/bin/perl';
print "Enter the *absolute pathname* to the Perl 5 executable.\n";
print "Enter 'return' for the default: $pXOq\n";
$fgFK='';
until($fgFK){
  print "Enter Perl 5 Pathname: ";
  $fgFK=<STDIN>;
  $fgFK=~s/[\n\r\s]//g;
  $fgFK=~s#\\#/#g;
  unless($fgFK){$fgFK=$pXOq;}
  stat($fgFK);
  if(! -e _ || -d _){print "Invalid entry: $fgFK\n";$fgFK='';}
}

$QiX='';
until($QiX=~m/^[yn]/i){
  print "\nIs LinkScan installed in a web-visible directory under www root? [y/n]: ";
  $QiX=<STDIN>;
  $QiX=~s/[\n\r]//g;
}
if($QiX=~m/^n/i){
  print "\nWhen prompted for a URL to the LinkScan directory, please supply the URL\n";
  print "to some other web-visible directory. You can create one later, if you prefer.\n";
  print "Then, copy the LinkScan docs/ directory (and the files therein) into that\n";
  print "directory so the LinkScan documentation can be viewed via a browser.\n";
}else{
  print "\nNow LinkScan needs a URL to *this* directory so that the documentation\n";
  print "and reports are available via a web browser.\n";
}
print "Enter the full URL. For example: http://www.example.com/linkscan/\n";
$wQSq='';
until($wQSq=~m#^https?://#){
  print "Enter LinkScan URL: ";
  $wQSq=<STDIN>;
  $wQSq=~s/[\n\r\s]//g;
}
unless($wQSq=~m#/$#) {$wQSq .='/';}
$Rwb=$wQSq;
$hRU=$PhK.'docs/';
$xUj=$wQSq.'docs/';
$eHU=$PhK.'reports/';
$hst=$wQSq.'reports/';

print "\n\nDoes your server require that CGI scripts be installed in a special\n";
print "directory (e.g. cgi-bin)?\n";
$sJbz='';
$jmYk=0;
$ncEt='';
until($sJbz=~m/^[yn]/i){
  print "[y/n]: ";
  $sJbz=<STDIN>;
  $sJbz=~s/[\n\r\s]//g;
  if($sJbz=~m/^y/i){$jmYk=1;}
}
if($jmYk){
  print "\n\nEnter the *absolute pathname* of your special cgi-bin directory.\n";
  print "For example: /usr/www/cgi-bin/\n";
  until($ncEt){
    print "Enter cgi-bin Pathname: ";
    $ncEt=<STDIN>;
    $ncEt=~s/[\n\r\s]//g;
    $ncEt=~s#\\#/#g;
    stat($ncEt);
    if(! -d _){print "Invalid entry: $ncEt\n";$ncEt='';}
  }
  unless($ncEt=~m#/$#){$ncEt .='/';}
  print "\n\nEnter the full URL to your special cgi-bin directory.\n";
  print "For example: http://www.example.com/cgi-bin/\n";
  $Rwb='';
  until($Rwb){
    print "Enter cgi-bin URL: ";
    $Rwb=<STDIN>;
    $Rwb=~s/[\n\r\s]//g;
    $Rwb=~s#\\#/#g;
    unless($Rwb=~m#^https*://#i){$Rwb='';}
  }
  unless($Rwb=~m#/$#){$Rwb .='/';}
}

print "\n\nDo you access the Internet via a Proxy Server?\n";
$sJbz='';
$Cmx='';
until($sJbz=~m/^[yn]/i){
  print "[y/n]: ";
  $sJbz=<STDIN>;
  $sJbz=~s/[\r\n\s]//g;
  if($sJbz=~m/^y/i){$Cmx=1;}
}
if($Cmx){
  $Cmx='';
  until($Cmx=~m/[a-zA-Z0-9\.\-]+/o){
    print "\n\nEnter the Proxy Server host name: ";
    $Cmx=<STDIN>;
    $Cmx=~s/[\r\n\s]//g;
  }
  $YbI='';
  until($YbI=~m/\d+/i){
    print "\n\nEnter the Proxy Port Number for HTTP: ";
    $YbI=<STDIN>;
    $YbI=~s/[\r\n\s]//g;
  }
  print "\n\nIf you need to access certain hosts and/or domains without the\n";
  print "Proxy Server, and/or your Proxy Server requires Proxy-Authentication,\n";
  print "you will need to configure the \"Proxyauth\" and \"Noproxy\" options\n";
  print "manually. Please see Section 6 of the LinkScan Reference Manual\n";
  print "Press 'return' to continue: ";
  $sJbz=<STDIN>;
}

print "\n\nNow LinkScan needs some information about the Website you want to scan.\n";
print "If LinkScan can access static HTML documents on this server via the local\n";
print "File System (or NFS) please enter the absolute file system pathname to the\n";
print "document root directory. Otherwise press return.\n";
print "For example: /usr/www/htdocs/\n";
print "Enter Home Directory: ";
$Nsj='';
until($Nsj){
  $Nsj=<STDIN>;
  $Nsj=~s/[\n\r\s]//g;
  unless($Nsj){last;}
  unless($Nsj=~m#/$#){$Nsj .='/';}
  stat($Nsj);
  if(! -d _){print "Invalid entry: $Nsj\n";$Nsj='';}
}

print "\n\nPlease enter the URL of the website you wish to scan.\n";
print "For example: http://www.example.com/\n";
$vqB='';
until($vqB=~m#^https?://#){
  print "Enter Home URL: ";
  $vqB=<STDIN>;
  $vqB=~s/[\n\r\s]//g;
}
$vqB=~m#^(https?://[^/]+/?)(.*)$#i;
$vqB=$1;
$HNq=$2;
unless($vqB=~m#/$#){$vqB .='/';}

$Zuv=1;
$ybY="me\100example.com";

open(SYS,">$qZs") or die "** Fatal Error: Could not write $qZs\n";
print "\nWriting configuration file $qZs ...\n";
print SYS <<END_CFG;

# LINKSCAN SYSTEM CONFIGURATION FILE - LINKSCAN.SYS
# !Version 11.7
#
# Lines beginning with "#" are comments
#
# Purpose:     The primary LinkScan system configuration file
# Location:    The LinkScan Directory only
# Required:    Always
# Applies to:  All configured Projects
# Inheritance: Not applicable
#
#==============================================================================
# ESSENTIAL PARAMETERS
#==============================================================================
#
# LicenseNumber  = 10-digit LinkScan License Number
# Licensee       = Company Name
# Key            = LinkScan License Key

LicenseNumber = $nYtP
Licensee = $hUp
Key = $djTJ

# Linkscandir    = Absolute File System Pathname to the LinkScan directory
# Perlpath       = Absolute File System Pathname the Perl 5 executable
# Weblintpath    = Absolute File System Pathname to the weblint executable
# Weblintoptions = Weblint command line options
# Cgibinurl      = Absolute URL to the LinkScan CGI's
# Docsurl        = Absolute URL to the LinkScan Documentation
# Reportsdir     = Absolute File System Pathname to the LinkScan Reports

Linkscandir = $PhK
Perlpath = $fgFK
Weblintpath = $HzY
Weblintoptions = -d extension-markup,extension-attribute
Cgibinurl = $Rwb
Docsurl = $xUj
Reportsdir = $eHU

# Email related settings
# Sendmailpath     = Absolute File System Pathname to the sendmail executable
#                    Include the sendmail -t switch
# Smtphost         = SMTP hostname -- not used on UNIX systems
# Hostname         = Fully qualified hostname for this server (SMTP: HELO)
# Mailfrom         = From address (SMTP: MAIL FROM)
# Nameservers      = Domain Name Servers to use (comma separated list)

Sendmailpath = /usr/lib/sendmail -t
Smtphost =
Hostname = $ueV
Mailfrom =
Nameservers =

# Proxyserver      = The name of your HTTP Proxy Server (blank if none)
# Proxyport        = The port number of your HTTP Proxy Server
# Httpsproxyserver = The name of your HTTPS Proxy Server (blank if none)
# Httpsproxyport   = The port number of your HTTPS Proxy Server
# Noproxy          = Do not use Proxy for these servers (comma delimited list)
# Proxyauth        = "username:password" for Proxy Server authentication
# FTPUser          = Username to be used for anonymous FTP
# FTPPass          = Password to be used for anonymous FTP
# Linespeed        = Default line speed for slowest pages report
#                    1 = 28.8, 2 = 56K, 3 = ISDN, 4 = DSL, 5 = T-1

Proxyserver = $Cmx
Proxyport = $YbI
Httpsproxyserver =
Httpsproxyport = 80
Noproxy =
Proxyauth =
FTPUser = anonymous
FTPPass = $ybY
Linespeed = 1

#==============================================================================
# OPTIONAL PARAMETERS
#==============================================================================
#
# LINK CHECKING PARAMETERS
#
# Masterhist     = Maintain site history data globally for all Projects
# Maxhist        = Max number of history entries to be stored
# Maxgoodhours   = Max number of hours between attempts to retest good ext links
# Maxbadhours    = Max number of hours between attempts to retest bad ext links
# Timeout1       = Timeout (in seconds) for first attempt to contact site
# Timeout2       = Timeout (in seconds) for second attempt to contact site
# Masterport     = Start of TCP/IP port number sequence used internally
# Slaves1        = Number of slaves for internal links
# Slaves2        = Number of slaves for external links
# Slavesfast1    = Number of slaves for internal links (with -fast option)
# Slavesfast2    = Number of slaves for external links (with -fast option)

Masterhist = 1
Maxhist = 10
Maxgoodhours = 4
Maxbadhours = 0
Timeout1 = 20
Timeout2 = 40
Masterport = 8010
Slaves1 = 3
Slaves2 = 6
Slavesfast1 = 5
Slavesfast2 = 12

# SERVER AND CGI ACCESS CONTROLS
#
# Linkscancookie = Type of cookie set by linkscan.cgi
#                  0=permanent; 1=session; 2=none
# Notapmapoptions= Disable the Options Menu on LinkScan/TapMap
# Noprojectlist  = Prompt for Project versus displaying drop-down list
# Nostaticmenu   = Disable the Menu Tools of command-line generated reports
# Httpauth       = Environment variable to check for HTTP user authentication
# Mailto         = Enable mailto option on LinkScan Reports (2=with comment box)

Linkscancookie = 0
Notapmapoptions = 0
Noprojectlist = 0
Nostaticmenu = 0
Httpauth = REMOTE_USER
Mailto = 1

# SERVER ACCESS CONTROLS (LinkScan WebServer only)
#
# Serverdeny     = IPaddress - deny access from IP address
# Serverallow    = IPaddress - allow access from IP address
# Serverauth     = username:password - use HTTP Basic Authentication
# Serverindex    = Allow server generated directory listings
#
# Serverdeny is processed before Serverallow. For example:
#   Serverdeny = .*
#   Serverallow = 10.10.10.10
#   Serverauth = myname:mypass
#   Serverindex = 0

Serverallow = .*
Serverindex = 1

# CGI ACCESS CONTROLS (Apply to any server)
#
# Access = username : password : project-list : owner-list : menu-options
#
# Use "*" for "any".
# project-list and owner-list are comma-delimited lists.
#
# Valid menu-options: xeskdbuvmycaohrpiqt
#
# x = Project Summary Report
# e = Problem Documents Report
# s = Document Detail Report
# k = Critical Errors Report
# d = Detailed Errors Report
# b = Changed Documents Report
# u = Search Documents Report
# v = Search Links Report
# m = SiteMap Report
# y = Summary of All Projects
# c = Selected Status Codes Report
# a = All Pages Linking To ... Report
# o = Orphaned Files Report
# h = External History Report
# r = Redirections Report
# p = System Configuration Report
# i = Document Weight Report
# q = LinkScan/QuickCheck
# t = LinkScan/TapMap
#
# The following default entry creates UNRESTRICTED ACCESS
#
# Access = * : * : * : * : *
#
# !1

Access = * : * : * : * : *

#==============================================================================
# PLEASE DO NOT CHANGE ITEMS BELOW THIS LINE
#==============================================================================

Helpcode8 = links07.html
Helpfile = linkscan.html
Mainmenu = linkscan.cgi
Mapcgi = linkmap.cgi
Statuscodefile = codes.txt
Templatefile = template.txt
Quickcgi = quick.cgi

QSource = 1
QLinkscan = 1
QWeblint = 0
QFormat = 1
QAdv = 0
QSev0 = 0
QSev1 = 1
QSev2 = 1
QSev3 = 1
QSev4 = 0
QSev5 = 0

#==============================================================================
# LinkScan
#==============================================================================
# (c) Copyright 1997-2007 Electronic Software Publishing Corporation (Elsop)
# All Rights Reserved.
# LinkScan(TM) and Elsop(TM) are Trademarks of
# Electronic Software Publishing Corporation.
# Email: linkscan\@elsop.com
# WWW: http://www.elsop.com/
#==============================================================================
# The end
#==============================================================================

END_CFG
close(SYS);

$jPcD="user\@Mailhost";
open(SYS,">$znL") or die "** Fatal Error: Could not write $znL\n";
print "Writing configuration file $znL ...\n";
print SYS <<END_CFG;

# LINKSCAN SITE CONFIGURATION FILE - LINKSCAN.CFG
# !Version 11.7
#
#==============================================================================
# THIS FILE BELONGS IN THE PROJECT DIRECTORY. EACH PROJECT INHERITS
# THE GLOBAL SETTINGS SPECIFIED IN THE LINKSCAN DIRECTORY. ANY OF
# THOSE SETTINGS MAY BE OVERRIDEN IN THIS PROJECT-SPECIFIC FILE.
#==============================================================================
#
# Lines beginning with "#" are comments
#
# Purpose:     The LinkScan Project configuration file
# Location:    The LinkScan directory and/or the Project Directory
# Required:    Yes
# Applies to:  The selected Project
# Inheritance: The LinkScan Directory is checked first. Those settings are
#              overriden or added to by the linkscan.cfg file in the selected
#              Project Directory
#
#==============================================================================
# ESSENTIAL PARAMETERS - MUST BE CONFIGURED
#==============================================================================
#
# Homedir       = Absolute pathname to the server root
# Homeurl       = Absolute URL to the server root
#                 Homedir and Homeurl *must* point at the *same* directory
# Mirrorurl     = Alternate URL to use for HTTP fetch requests
# Homefile      = Relative pathname to the starting page
# Mask          = Onlyinclude pathnames matching mask
# Projectdesc   = Project Description
# Organization  = Name of your organization for the reports
#
# Note: Specify subdirectories using Homefile rather than Homedir/Homeurl
# For example:
# Homedir = /usr/www/htdocs/
# Homeurl = http://localhost/
# Homefile = subdir/index.html

Homedir = $Nsj
Homeurl = $vqB
Mirrorurl =
Homefile = $HNq
Mask =
Projectdesc = $OXo
Organization = $OXo

# Http          = Use remote HTTP access to a non-local website
# Autohttp      = Automatically try HTTP access if File System access fails
# Casesensitive = Pathnames on the local server are case sensitive
# Maxcgi        = Max number of times any one script is probed with different
#                 query parameters
# Followext     = Follow redirections when scanning external links
# Retryext      = Retry external links at end of scan
# Showredirext  = Show external redirections
# Htmlfiles     = Files with these extensions are assumed to contain html
# Mapfiles      = Files with these extensions are assumed to contain imagemaps
# Pdffiles      = Files with these extensions are assumed to contain PDF docs
# Flashfiles    = Files with these extensions are assumed to contain Flash docs
# Textfiles     = Files with these extensions are assumed to contain plaintext
# Defaultpages  = LinkScan looks for these files in the order specified
# Indexoptions  = LinkScan will generate an index if no default page present
# Import        = Select Import mode; 1=links; 2=documents; 3=nocache
# Importfile    = Absolute pathname to import file
# Noorphan      = Disable Orphan checking
# Orphanfile    = Pathname to imported file system listing from lsfind
# Autoowner     = Automatic owner generation based on top-level dir

Http = 0
Autohttp = 0
Casesensitive = 1
Maxcgi = 100
Followext = 1
Retryext = 1
Showredirext = 0
Htmlfiles = html, shtml, htm
Mapfiles = map
Pdffiles =
Flashfiles = swf
Textfiles = txt
Defaultpages = index.html, index.shtml, index.htm, home.html, home.shtml, home.htm
Indexoptions = 0
Import = 0
Importfile =
Noorphan = 0
Orphanfile =
Autoowner = 1

#============================================================================
# OPTIONAL LINKSCAN CUSTOMIZATION COMMANDS
#==============================================================================



#==============================================================================
# SUMMARY OF LINKSCAN CUSTOMIZATION COMMANDS [aide memoire]
#==============================================================================
# SINGLE-VALUED COMMANDS [last occurrence counts]
#
# Checkmailto = boolean
# Closeatag = boolean
# Collectmeta = boolean
# Defaultowner = owner-name
# Editdoc = absolute-url-expression
# Editlink = absolute-url-expression
# Errorbody = expression
# Errordoc = relative-url-expression
# Expandssi = boolean
# Fetchext = boolean
# Followext = boolean
# Followframes = boolean
# Imgtags = [AHW]
# Maxclicks = integer
# Maxlevels = integer
# Noexternal = boolean
# Noforms = boolean
# Nohash = boolean
# Nomap = boolean
# Noorphan = boolean
# Nosplit = boolean
# Ownertags = expression
# Profiler = integer
# Profilerlog = boolean
# Profilermax = integer
# Sessionmatch = expression
# Showredirext = boolean
#
# USER-AGENT EXAMPLES
# Extraheader User-Agent: Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0)
# Extraheader User-Agent: Mozilla/4.08 [en] (WinNT; I ;Nav)
#
# MULTI-VALUED COMMANDS [all occurrences count]
#
# Alias relative-path-expression absolute-path-expression
# Auth server-name "realm-name" username password
# Checkorphans relative-path-expression
# Cookie server-name cookie-name=cookie-value
# Exclude relative-path-expression
# Exclude absolute-url-expression
# Excludecookie expression
# Execute relative-path-expression
# Extraheader http-header-line
# Extrahome relative-path-expression
# Hostalias server-url
# Insertlink document-match new-document [-|+|*]
# Mailalias expression list-of-addresses
# Mimetypes mime-type [D|H|J|S|T]
# Nofollow relative-path-expression
# Noorphans relative-path-expression
# Onlyfollow relative-path-expression
# Onlyinclude relative-path-expression
# Onlyorphans relative-path-expression
# Owner relative-path-expression owner-name
# Owner *1
# Owneralias expression owner-name
# Redirect relative-path-expression absolute-url-expression
# Scriptexclude expression
# Scriptmatch expression
# Scriptnomatch expression
# Selecturl expression
# Sessionmatch expression
# Statuscode statuscode, severity
# Substitute relative-path-expression expression
# Substituteraw relative-path-expression expression
# Taglimit relative-path-expression maxnumber
# Tagonce relative-path-expression
# Userdata [123] match-expression expression
# Userdatafmt [123] [DHLTX] integer[LRC] caption
# Userdatasub [123] expression expression
#
# SITEMAP CUSTOMIZATION COMMANDS
#
# Mapdefaulttitle, [ string ] [ !PATH | !FILE ] [ string ]
# Mapext, boolean
# Mapinclude, relative-path-expression
# Maphide, relative-path-expression
# Mapmove, relative-document-path, new-parent-relative-path, position, new-title
# Maptitle, relative-document-path, new-title
#
#==============================================================================
# LinkScan
#==============================================================================
# (c) Copyright 1997-2007 Electronic Software Publishing Corporation (Elsop)
# All Rights Reserved.
# LinkScan(TM) and Elsop(TM) are Trademarks of
# Electronic Software Publishing Corporation.
# Email: linkscan\@elsop.com
# WWW: http://www.elsop.com/
#==============================================================================
# The end
#==============================================================================

END_CFG
close(SYS);

print "Updating shebang headers ...\n";
@GkM=("linkscan.pl","linkscan2.pl","dispatch.pl","linkscan.cgi","linkmap.cgi","quick.cgi","linkdiag.pl","slave.pl","pinger.pl","utils/makeign.pl","utils/sendmail.pl","utils/tools.cgi");
foreach $RcAu(@GkM){
  $KIiP='';
  open(IN,"<$RcAu") || print "** Error: Opening $RcAu $!\n";
  open(OUT,">$RcAu.tmp") || print "** Error: Opening $RcAu.tmp $!\n";
  while(<IN>){
    $Asw=$_;
    if(! $KIiP && $Asw =~ m/^#!/){
      $Asw="#!$fgFK\n";
      $KIiP=1;
    }
    print OUT $Asw;
  }
  close(IN);
  close(OUT);
  unlink($RcAu) || print "** Error: Deleting $RcAu $!\n";
  rename("$RcAu.tmp", $RcAu) || print "** Error: Renaming $RcAu.tmp $!\n";
  chmod(0755,$RcAu);
}

if($jmYk){
  print "Updating cgi scripts and copying them to $ncEt ...\n";
  @GkM=('linkscan.cgi','linkmap.cgi','quick.cgi');
  foreach $RcAu(@GkM){
    $KIiP='';
    open(IN,"<$RcAu") || print "** Error: Opening $RcAu $!\n";
    open(OUT,">$ncEt$RcAu") || print "** Error: Opening $ncEt$RcAu $!\n";
    while(<IN>){
      $Asw=$_;
      print OUT $Asw;
    }
    close(IN);
    close(OUT);
    chmod(0755,$ncEt.$RcAu);
  }
  open(OUT,">$ncEt\.linkscan") || print "** Error: Opening $ncEt\.linkscan $!\n";
  print OUT "$PhK\n";
  close(OUT);
  chmod(0644,"$ncEt\.linkscan");
}

$gRn='';
open(IN,"<index.html");
while(<IN>){
  $gRn .=$_;
}
close(IN);
$gRn=~s/<a\s+href\s*=\s*".*?(linkscan\.cgi|quick\.cgi)"/<a href="$Rwb$1"/gis;
open(OUT,">index.html");
print OUT $gRn;
close(OUT);

print "Completed.\n\n";
print "You may examine the following files using your favorite editor:\n";
print "  $qZs\n";
print "  $znL\n\n";
print "Execute linkscan.pl to run LinkScan.\n\n";
exit;
## MTkxNDc4Mg==

## End of file
